/*
 * Copyright (c) 2016, 2017, 2018, 2019 FabricMC
 * Copyright 2022 The Quilt Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.fabricmc.fabric.api.client.screen.v1;

import java.util.List;
import java.util.Objects;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_339;
import net.minecraft.class_437;
import org.quiltmc.qsl.screen.api.client.QuiltScreen;

/**
 * Utility methods related to screens.
 *
 * @see ScreenEvents
 * @deprecated Use Quilt Screen API's {@link org.quiltmc.qsl.screen.api.client.QuiltScreen} instead.
 */
@Deprecated
public final class Screens {
	/**
	 * Gets all of a screen's button widgets.
	 * The provided list allows for addition and removal of buttons from the screen.
	 * This method should be preferred over adding buttons directly to a screen's {@link class_437#method_25396() child elements}.
	 *
	 * @return a list of all of a screen's buttons
	 */
	public static List<class_339> getButtons(class_437 screen) {
		Objects.requireNonNull(screen, "Screen cannot be null");

		return ((QuiltScreen) screen).getButtons();
	}

	/**
	 * Gets a screen's text renderer.
	 *
	 * @return the screen's text renderer.
	 */
	public static class_327 getTextRenderer(class_437 screen) {
		Objects.requireNonNull(screen, "Screen cannot be null");

		return ((QuiltScreen) screen).getTextRenderer();
	}

	public static class_310 getClient(class_437 screen) {
		Objects.requireNonNull(screen, "Screen cannot be null");

		return ((QuiltScreen) screen).getClient();
	}

	private Screens() {
	}
}
